Imports System
Imports System.Windows.Forms
Imports System.Drawing
Imports GTA

Public Class SuperJump
    Inherits Script

    Dim asJumpSTD As New GTA.AnimationSet("jump_std")
    Dim asJumpRIFLE As New GTA.AnimationSet("jump_rifle")
    Dim bScriptEnabled As Boolean = True
    Dim kKeyIncreaseMult As Keys = Keys.Right 'Key that decreases jump multiplier | Keys.Right
    Dim kKeyDecreaseMult As Keys = Keys.Left 'Key that increases jump multiplier | Keys.Left
    Dim kKeyToggleScript As Keys = Keys.B 'Key that turns the script on/off | Default = Keys.B
    Dim sPlayerJumpX As Single = 0
    Dim sPlayerJumpY As Single = 0
    Dim sPlayerJumpZ As Single = 0
    Dim sLJumpMultiplier As Single = 1.1 'When the script first loads this is the long jump multiplier | Default = 1.1
    Dim sJumpMultiplier As Single = 1.5 'When the script first loads this is the jump multiplier | Default = 1.5
    Dim sLInterval As Single = 0.05 'Change this to set the amount the long jump multiplier increases or decreases (keep less than the jump interval)| Default = 0.05
    Dim sInterval As Single = 0.1 'Change this to set the amount the jump multiplier increases or decreases | Default = 0.1
    Dim vecPlayerJump As Vector3

    Private Sub SuperJump_ConsoleCommand(sender As Object, e As GTA.ConsoleEventArgs) Handles Me.ConsoleCommand
        If e.Command = "DisplayMult" Then
            GTA.Game.Console.Print(sJumpMultiplier.ToString)
        End If
    End Sub

    Private Sub SuperJump_Tick(sender As Object, e As System.EventArgs) Handles Me.Tick
        If Player.Character.Animation.isPlaying(asJumpSTD, "jump_takeoff_l") Then
            SuperJumpForce()
        ElseIf Player.Character.Animation.isPlaying(asJumpSTD, "jump_takeoff_r") Then
            SuperJumpForce()
        ElseIf Player.Character.Animation.isPlaying(asJumpSTD, "jump_on_spot") Then
            SuperJumpForceStandStill()
        ElseIf Player.Character.Animation.isPlaying(asJumpRIFLE, "jump_takeoff_l") Then
            SuperJumpForce()
        ElseIf Player.Character.Animation.isPlaying(asJumpRIFLE, "jump_takeoff_r") Then
            SuperJumpForce()
        ElseIf Player.Character.Animation.isPlaying(asJumpRIFLE, "jump_on_spot") Then
            SuperJumpForceStandStill()
        End If

        If isKeyPressed(kKeyDecreaseMult) Then
            sJumpMultiplier -= sInterval
            sLJumpMultiplier -= sLInterval
            GTA.Game.DisplayText("Jump Mult: " & sJumpMultiplier.ToString & " | " & "L Jump Mult: " & sLJumpMultiplier.ToString, 1000)
        ElseIf isKeyPressed(kKeyIncreaseMult) Then
            sJumpMultiplier += sInterval
            sLJumpMultiplier += sLInterval
            GTA.Game.DisplayText("Jump Mult: " & sJumpMultiplier.ToString & " | " & "L Jump Mult: " & sLJumpMultiplier.ToString, 1000)
        ElseIf isKeyPressed(kKeyToggleScript) Then
            If bScriptEnabled = False Then
                bScriptEnabled = True
                GTA.Game.DisplayText("SuperJump Enabled", 1500)
				Wait(150)
            ElseIf bScriptEnabled = True Then
                bScriptEnabled = False
                GTA.Game.DisplayText("SuperJump Disabled", 1500)
				Wait(150)
			End If
        End If
        'GTA.Game.DisplayText(Player.Character.Animation.GetCurrentAnimationTime(asJumpSTD, "jump_on_spot"))
    End Sub

    Private Sub SuperJumpForce()
        If bScriptEnabled = True Then
            sPlayerJumpX = Player.Character.Velocity.X
            sPlayerJumpY = Player.Character.Velocity.Y
            sPlayerJumpZ = Player.Character.Velocity.Z
            vecPlayerJump.X = sPlayerJumpX * sLJumpMultiplier
            vecPlayerJump.Y = sPlayerJumpY * sLJumpMultiplier
            vecPlayerJump.Z = sPlayerJumpZ * sJumpMultiplier
            Player.Character.Velocity = vecPlayerJump
        End If
    End Sub

    Private Sub SuperJumpForceStandStill()
        If bScriptEnabled = True Then
            If Player.Character.Animation.GetCurrentAnimationTime(asJumpSTD, "jump_on_spot") > 0.28 Then
                If Player.Character.Animation.GetCurrentAnimationTime(asJumpSTD, "jump_on_spot") < 0.35 Then
                    PerformJumpSub()
                End If
            ElseIf Player.Character.Animation.GetCurrentAnimationTime(asJumpRIFLE, "jump_on_spot") > 0.28 Then
                If Player.Character.Animation.GetCurrentAnimationTime(asJumpRIFLE, "jump_on_spot") < 0.35 Then
                    PerformJumpSub()
                End If
            End If
        End If
    End Sub

    Private Sub PerformJumpSub()
        sPlayerJumpX = Player.Character.Velocity.X
        sPlayerJumpY = Player.Character.Velocity.Y
        sPlayerJumpZ = Player.Character.Velocity.Z
        vecPlayerJump.X = sPlayerJumpX
        vecPlayerJump.Y = sPlayerJumpY
        vecPlayerJump.Z = 1.0 * sJumpMultiplier
        vecPlayerJump.Z = vecPlayerJump.Z * sJumpMultiplier
        vecPlayerJump.Z = vecPlayerJump.Z * sJumpMultiplier
        vecPlayerJump.Z = vecPlayerJump.Z * sJumpMultiplier
        Player.Character.Velocity = vecPlayerJump
    End Sub
End Class
